异常处理

异常是一个在程序执行期间发生的事件,它中断了正在执行的程序的正常指令流

Exception

  • 所有的异常类是从 java.lang.Exception 类继承的子类
  • Exception 类是 Throwable 类的子类。除了Exception类外,Throwable还有一个子类Error 。
  • Error 用来指示运行时环境发生的错误。例如,JVM 内存溢出。一般地,程序不会从错误中恢复。
  • 异常类有两个主要的子类:IOException 类和 RuntimeException 类。

Java 内置异常类

Java 根据各个类库也定义了一些其他的异常,下面的表中列出了 Java 的非检查性异常

异常 描述
ArithmeticException 当出现异常的运算条件时,抛出此异常。例如,一个整数”除以零”时,抛出此类的一个实例
ArrayIndexOutOfBoundsException 用非法索引访问数组时抛出的异常。如果索引为负或大于等于数组大小,则该索引为非法索引
ArrayStoreException 试图将错误类型的对象存储到一个对象数组时抛出的异常
ClassCastException 当试图将对象强制转换为不是实例的子类时,抛出该异常
IllegalArgumentException 抛出的异常表明向方法传递了一个不合法或不正确的参数
IllegalMonitorStateException 抛出的异常表明某一线程已经试图等待对象的监视器,或者试图通知其他正在等待对象的监视器而本身没有指定监视器的线程
IllegalStateException 在非法或不适当的时间调用方法时产生的信号。换句话说,即 Java 环境或 Java 应用程序没有处于请求操作所要求的适当状态下
IllegalThreadStateException 线程没有处于请求操作所要求的适当状态时抛出的异常
IndexOutOfBoundsException 指示某排序索引(例如对数组、字符串或向量的排序)超出范围时抛出
NegativeArraySizeException 如果应用程序试图创建大小为负的数组,则抛出该异常
NullPointerException 当应用程序试图在需要对象的地方使用 null 时,抛出该异常
NumberFormatException 当应用程序试图将字符串转换成一种数值类型,但该字符串不能转换为适当格式时,抛出该异常
SecurityException 由安全管理器抛出的异常,指示存在安全侵犯
StringIndexOutOfBoundsException 此异常由 String 方法抛出,指示索引或者为负,或者超出字符串的大小
UnsupportedOperationException 当不支持请求的操作时,抛出该异常

下面的表中列出了 Java 定义在 java.lang 包中的检查性异常类

异常 描述
ClassNotFoundException 应用程序试图加载类时,找不到相应的类,抛出该异常
CloneNotSupportedException 当调用 Object 类中的 clone 方法克隆对象,但该对象的类无法实现 Cloneable 接口时,抛出该异常
IllegalAccessException 拒绝访问一个类的时候,抛出该异常
InstantiationException 当试图使用 Class 类中的 newInstance 方法创建一个类的实例,而指定的类对象因为是一个接口或是一个抽象类而无法实例化时,抛出该异常
InterruptedException 一个线程被另一个线程中断,抛出该异常
NoSuchFieldException 请求的变量不存在
NoSuchMethodException 请求的方法不存在

异常方法

  • 下面的列表是 Throwable 类的主要方法:

  • public String getMessage()

    • 返回关于发生的异常的详细信息。这个消息在Throwable 类的构造函数中初始化了
  • public Throwable getCause()

    • 返回一个Throwable 对象代表异常原因
  • public String toString()

    • 使用getMessage()的结果返回类的串级名字
  • public void printStackTrace()

    • 打印toString()结果和栈层次到System.err,即错误输出流
  • public StackTraceElement [] getStackTrace()

    • 返回一个包含堆栈层次的数组。下标为0的元素代表栈顶,最后一个元素代表方法调用堆栈的栈底
  • public Throwable fillInStackTrace()

    • 用当前的调用栈层次填充Throwable 对象栈层次,添加到栈层次任何先前信息中|

捕获异常

使用 trycatch 关键字可以捕获异常。try/catch 代码块放在异常可能发生的地方

1
2
3
4
5
6
7
try
{
// 程序代码
}catch(ExceptionName e1)
{
//Catch 块
}

多重捕获块

一个 try 代码块后面跟随多个 catch 代码块的情况就叫多重捕获

1
2
3
4
5
6
7
8
9
10

try{
// 程序代码
}catch(异常类型1 异常的变量名1){
// 程序代码
}catch(异常类型2 异常的变量名2){
// 程序代码
}catch(异常类型3 异常的变量名3){
// 程序代码
}

finally关键字

  • finally 关键字用来创建在 try 代码块后面执行的代码块
  • 无论是否发生异常,finally 代码块中的代码总会被执行
  • finally 代码块中,可以运行清理类型等收尾善后性质的语句
1
2
3
4
5
6
7
8
9
ry{
// 程序代码
}catch(异常类型1 异常的变量名1){
// 程序代码
}catch(异常类型2 异常的变量名2){
// 程序代码
}finally{
// 程序代码
}

throws/throw 关键字

  • 如果一个方法没有捕获到一个检查性异常,那么该方法必须使用 throws 关键字来声明。throws 关键字放在方法签名的尾部
  • 也可以使用 throw 关键字抛出一个异常,无论它是新实例化的还是刚捕获到的
  • 下面方法的声明抛出一个 RemoteException 异常
1
2
3
4
5
6
7
8
9
10
11

import java.io.*;
public class className
{
public void deposit(double amount) throws RemoteException
{
// Method implementation
throw new RemoteException();
}
//Remainder of class definition
}
  • 一个方法可以声明抛出多个异常,多个异常之间用逗号隔开
  • 例如,下面的方法声明抛出 RemoteException 和 InsufficientFundsException:
1
2
3
4
5
6
7
8
9
10
11

import java.io.*;
public class className
{
public void withdraw(double amount) throws RemoteException,
InsufficientFundsException
{
// Method implementation
}
//Remainder of class definition
}

声明自定义异常

  • 在 Java 中你可以自定义异常。编写自己的异常类时需要记住下面的几点
    • 所有异常都必须是 Throwable 的子类
    • 如果希望写一个检查性异常类,则需要继承 Exception
    • 如果你想写一个运行时异常类,那么需要继承 RuntimeException
  • 可以像下面这样定义自己的异常类:
1
2
class MyException extends Exception{
}

以下实例是一个银行账户的模拟,通过银行卡的号码完成识别,可以进行存钱和取钱的操作

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18

// 文件名InsufficientFundsException.java
import java.io.*;

//自定义异常类,继承Exception类
public class InsufficientFundsException extends Exception
{
//此处的amount用来储存当出现异常(取出钱多于余额时)所缺乏的钱
private double amount;
public InsufficientFundsException(double amount)
{
this.amount = amount;
}
public double getAmount()
{
return amount;
}
}

为了展示如何使用我们自定义的异常类,在下面的 CheckingAccount 类中包含一个 withdraw() 方法抛出一个 InsufficientFundsException 异常

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
/ 文件名称 CheckingAccount.java
import java.io.*;

//此类模拟银行账户
public class CheckingAccount
{
//balance为余额,number为卡号
private double balance;
private int number;
public CheckingAccount(int number)
{
this.number = number;
}
//方法:存钱
public void deposit(double amount)
{
balance += amount;
}
//方法:取钱
public void withdraw(double amount) throws
InsufficientFundsException
{
if(amount <= balance)
{
balance -= amount;
}
else
{
double needs = amount - balance;
throw new InsufficientFundsException(needs);
}
}
//方法:返回余额
public double getBalance()
{
return balance;
}
//方法:返回卡号
public int getNumber()
{
return number;
}
}

下面的 BankDemo 程序示范了如何调用 CheckingAccount 类的 deposit() 和 withdraw() 方法

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23

//文件名称 BankDemo.java
public class BankDemo
{
public static void main(String [] args)
{
CheckingAccount c = new CheckingAccount(101);
System.out.println("Depositing $500...");
c.deposit(500.00);
try
{
System.out.println("\nWithdrawing $100...");
c.withdraw(100.00);
System.out.println("\nWithdrawing $600...");
c.withdraw(600.00);
}catch(InsufficientFundsException e)
{
System.out.println("Sorry, but you are short $"
+ e.getAmount());
e.printStackTrace();
}
}
}
  • 编译上面三个文件,并运行程序 BankDemo,得到结果如下所示:
1
2
3
4
5
6
7
8
9
Depositing $500...

Withdrawing $100...

Withdrawing $600...
Sorry, but you are short $200.0
InsufficientFundsException
at CheckingAccount.withdraw(CheckingAccount.java:25)
at BankDemo.main(BankDemo.java:13)

通用异常

  • 在Java中定义了两种类型的异常和错误
    • JVM(Java虚拟机) 异常:由 JVM 抛出的异常或错误。例如:NullPointerException 类,ArrayIndexOutOfBoundsException 类,ClassCastException 类
    • 程序级异常:由程序或者API程序抛出的异常。例如 IllegalArgumentException 类,IllegalStateException 类